import org.jetbrains.kotlin.gradle.dsl.KotlinVersion
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.defineAllMultiplatformTargets
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.optInContracts
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.defineXomrkGiteaMavenRepo
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.plugin.xomrk
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.setCompatibilityWithKotlin
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.warningsAsErrors

buildscript {
	repositories {
		mavenCentral()
		maven("https://maven.landgrafhomyak.ru/")
	}

	dependencies {
		classpath("ru.landgrafhomyak.kotlin:kotlin-mpp-gradle-build:v0.2k2.0.20")
	}
}

group = "ru.landgrafhomyak.kotlin"
version = "v0.1"

repositories {
	mavenCentral()
}

xomrk {
	kotlin {
		explicitApi()
		warningsAsErrors()
		optInContracts()
		setCompatibilityWithKotlin(KotlinVersion.KOTLIN_1_7)

		jvmToolchain(8)
		defineAllMultiplatformTargets()
	}

	publishing {
		repositories {
			defineXomrkGiteaMavenRepo()
		}
	}
}