@file:JvmName("_IntVariables")

package ru.landrafhomyak.kotlin.utilities

import kotlin.jvm.JvmField
import kotlin.jvm.JvmName

public class ByteVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmField
	public var value: Byte
) {
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmName("getAndSet")
	public fun getAndSet(newValue: Byte): Byte {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	@JvmName("getAndAdd")
	public fun getAndAdd(d: Byte): Byte = this.getAndSet((this.value + d).trimToByte())

	@JvmName("getAndSub")
	public fun getAndSub(d: Byte): Byte = this.getAndSet((this.value - d).trimToByte())

	@JvmName("addAndGet")
	public fun addAndGet(d: Byte): Byte {
		this.value = (this.value + d).trimToByte()
		return this.value
	}

	@JvmName("subAndGet")
	public fun subAndGet(d: Byte): Byte {
		this.value = (this.value - d).trimToByte()
		return this.value
	}
}

public class UByteVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	public var value: UByte
) {
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmName("getAndSet")
	public fun getAndSet(newValue: UByte): UByte {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	@JvmName("getAndAdd")
	public fun getAndAdd(d: UByte): UByte = this.getAndSet((this.value + d).trimToUByte())

	@JvmName("getAndSub")
	public fun getAndSub(d: UByte): UByte = this.getAndSet((this.value - d).trimToUByte())

	@JvmName("addAndGet")
	public fun addAndGet(d: UByte): UByte {
		this.value = (this.value + d).trimToUByte()
		return this.value
	}

	@JvmName("subAndGet")
	public fun subAndGet(d: UByte): UByte {
		this.value = (this.value - d).trimToUByte()
		return this.value
	}
}

public class ShortVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmField
	public var value: Short
) {
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmName("getAndSet")
	public fun getAndSet(newValue: Short): Short {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	@JvmName("getAndAdd")
	public fun getAndAdd(d: Short): Short = this.getAndSet((this.value + d).trimToShort())

	@JvmName("getAndSub")
	public fun getAndSub(d: Short): Short = this.getAndSet((this.value - d).trimToShort())

	@JvmName("addAndGet")
	public fun addAndGet(d: Short): Short {
		this.value = (this.value + d).trimToShort()
		return this.value
	}

	@JvmName("subAndGet")
	public fun subAndGet(d: Short): Short {
		this.value = (this.value - d).trimToShort()
		return this.value
	}
}

public class UShortVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	public var value: UShort
) {
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmName("getAndSet")
	public fun getAndSet(newValue: UShort): UShort {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	@JvmName("getAndAdd")
	public fun getAndAdd(d: UShort): UShort = this.getAndSet((this.value + d).trimToUShort())

	@JvmName("getAndSub")
	public fun getAndSub(d: UShort): UShort = this.getAndSet((this.value - d).trimToUShort())

	@JvmName("addAndGet")
	public fun addAndGet(d: UShort): UShort {
		this.value = (this.value + d).trimToUShort()
		return this.value
	}

	@JvmName("subAndGet")
	public fun subAndGet(d: UShort): UShort {
		this.value = (this.value - d).trimToUShort()
		return this.value
	}
}

public class IntVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmField public var value: Int
) {
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmName("getAndSet")
	public fun getAndSet(newValue: Int): Int {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	@JvmName("getAndAdd")
	public fun getAndAdd(d: Int): Int = this.getAndSet(this.value + d)

	@JvmName("getAndSub")
	public fun getAndSub(d: Int): Int = this.getAndSet(this.value - d)

	@JvmName("addAndGet")
	public fun addAndGet(d: Int): Int {
		this.value += d
		return this.value
	}

	@JvmName("subAndGet")
	public fun subAndGet(d: Int): Int {
		this.value -= d
		return this.value
	}
}

public class UIntVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	public var value: UInt
) {
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmName("getAndSet")
	public fun getAndSet(newValue: UInt): UInt {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	@JvmName("getAndAdd")
	public fun getAndAdd(d: UInt): UInt = this.getAndSet(this.value + d)

	@JvmName("getAndSub")
	public fun getAndSub(d: UInt): UInt = this.getAndSet(this.value - d)

	@JvmName("addAndGet")
	public fun addAndGet(d: UInt): UInt {
		this.value += d
		return this.value
	}

	@JvmName("subAndGet")
	public fun subAndGet(d: UInt): UInt {
		this.value -= d
		return this.value
	}
}

public class LongVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmField
	public var value: Long
) {
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmName("getAndSet")
	public fun getAndSet(newValue: Long): Long {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	@JvmName("getAndAdd")
	public fun getAndAdd(d: Long): Long = this.getAndSet(this.value + d)

	@JvmName("getAndSub")
	public fun getAndSub(d: Long): Long = this.getAndSet(this.value - d)

	@JvmName("addAndGet")
	public fun addAndGet(d: Long): Long {
		this.value += d
		return this.value
	}

	@JvmName("subAndGet")
	public fun subAndGet(d: Long): Long {
		this.value -= d
		return this.value
	}
}

public class ULongVariable(
	@Suppress("MemberVisibilityCanBePrivate")
	public var value: ULong
) {
	@Suppress("MemberVisibilityCanBePrivate")
	@JvmName("getAndSet")
	public fun getAndSet(newValue: ULong): ULong {
		val oldValue = this.value
		this.value = newValue
		return oldValue
	}

	@JvmName("getAndAdd")
	public fun getAndAdd(d: ULong): ULong = this.getAndSet(this.value + d)

	@JvmName("getAndSub")
	public fun getAndSub(d: ULong): ULong = this.getAndSet(this.value - d)

	@JvmName("addAndGet")
	public fun addAndGet(d: ULong): ULong {
		this.value += d
		return this.value
	}

	@JvmName("subAndGet")
	public fun subAndGet(d: ULong): ULong {
		this.value -= d
		return this.value
	}
}