@file:JvmName("_Nulls")

package ru.landrafhomyak.kotlin.utilities

import kotlin.contracts.InvocationKind
import kotlin.contracts.contract
import kotlin.jvm.JvmName

@JvmName("onNull")
public inline fun <T> T?.onNull(action: () -> Unit): T? {
	contract {
		callsInPlace(action, InvocationKind.AT_MOST_ONCE)
	}

	if (this == null)
		action()

	return this
}


@JvmName("mapNull")
public inline fun <T : R, R> T?.mapNull(action: () -> R): R {
	contract {
		callsInPlace(action, InvocationKind.AT_MOST_ONCE)
	}

	return this ?: action()
}


@JvmName("onNotNull")
public inline fun <T> T?.onNotNull(action: (T) -> Unit): T? {
	contract {
		callsInPlace(action, InvocationKind.AT_MOST_ONCE)
	}

	if (this != null)
		action(this)

	return this
}